package com.example.catchTheLetters.entity;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 关卡类
 *
 * @author spyn
 */
@Data
public class Level implements Serializable {
    /**
     * 关卡ID
     */
    private String id;
    /**
     * 关卡序号（和id不一致，是关卡在游戏中的顺序）
     */
    private Integer order;
    /**
     * 关卡名称
     */
    private String name;
    /**
     * 关卡类型
     * -0：拼完题设单词
     * -1：达成目标分数
     */
    private Integer type;
    /**
     * 限时（可选，毫秒数）
     */
    private Long timeLimit;
    /**
     * 目标分数（type=1时有效）
     */
    private Integer targetScore;
    /**
     * 单词列表
     */
    private List<String> words;

    public Level() {
    }

    public Level(String id, Integer order, String name, Integer type, Long timeLimit, Integer targetScore, List<String> words) {
        this.id = id;
        this.order = order;
        this.name = name;
        this.type = type;
        this.timeLimit = timeLimit;
        this.targetScore = targetScore;
        this.words = words;
    }
}
